Index: pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj/project.pbxproj
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj/project.pbxproj	(revision 5291)
+++ pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj/project.pbxproj	(revision 5443)
@@ -8,4 +8,6 @@
 
 /* Begin PBXBuildFile section */
+		3A31F1B01DA4F54B007C23A3 /* libstdc++.tbd in Frameworks */ = {isa = PBXBuildFile; fileRef = 3A31F1AF1DA4F54B007C23A3 /* libstdc++.tbd */; };
+		3A31F1B21DA4F568007C23A3 /* libwebrtc.a in Frameworks */ = {isa = PBXBuildFile; fileRef = 3A31F1B11DA4F568007C23A3 /* libwebrtc.a */; };
 		3AA31FF618F3FB4C00112C3D /* AudioToolbox.framework in Frameworks */ = {isa = PBXBuildFile; fileRef = 3AA31FE918F3FB4C00112C3D /* AudioToolbox.framework */; };
 		3AA31FF718F3FB4C00112C3D /* AVFoundation.framework in Frameworks */ = {isa = PBXBuildFile; fileRef = 3AA31FEA18F3FB4C00112C3D /* AVFoundation.framework */; };
@@ -36,5 +38,4 @@
 		3AF0582516F050780046B835 /* ipjsuaViewController_iPhone.xib in Resources */ = {isa = PBXBuildFile; fileRef = 3AF0582316F050780046B835 /* ipjsuaViewController_iPhone.xib */; };
 		3AF0582816F050780046B835 /* ipjsuaViewController_iPad.xib in Resources */ = {isa = PBXBuildFile; fileRef = 3AF0582616F050780046B835 /* ipjsuaViewController_iPad.xib */; };
-		3AFFF4DA19BD59AB0067F226 /* libstdc++.dylib in Frameworks */ = {isa = PBXBuildFile; fileRef = 3AFFF4D919BD59AB0067F226 /* libstdc++.dylib */; };
 		E5E991E61B67A45500017E67 /* libg7221codec.a in Frameworks */ = {isa = PBXBuildFile; fileRef = E5E991D41B67A45500017E67 /* libg7221codec.a */; };
 		E5E991E71B67A45500017E67 /* libgsmcodec.a in Frameworks */ = {isa = PBXBuildFile; fileRef = E5E991D51B67A45500017E67 /* libgsmcodec.a */; };
@@ -58,4 +59,6 @@
 
 /* Begin PBXFileReference section */
+		3A31F1AF1DA4F54B007C23A3 /* libstdc++.tbd */ = {isa = PBXFileReference; lastKnownFileType = "sourcecode.text-based-dylib-definition"; name = "libstdc++.tbd"; path = "usr/lib/libstdc++.tbd"; sourceTree = SDKROOT; };
+		3A31F1B11DA4F568007C23A3 /* libwebrtc.a */ = {isa = PBXFileReference; lastKnownFileType = archive.ar; name = libwebrtc.a; path = libwebrtc.a; sourceTree = "<group>"; };
 		3AA31FE918F3FB4C00112C3D /* AudioToolbox.framework */ = {isa = PBXFileReference; lastKnownFileType = wrapper.framework; name = AudioToolbox.framework; path = System/Library/Frameworks/AudioToolbox.framework; sourceTree = SDKROOT; };
 		3AA31FEA18F3FB4C00112C3D /* AVFoundation.framework */ = {isa = PBXFileReference; lastKnownFileType = wrapper.framework; name = AVFoundation.framework; path = System/Library/Frameworks/AVFoundation.framework; sourceTree = SDKROOT; };
@@ -91,5 +94,4 @@
 		3AF0582416F050780046B835 /* en */ = {isa = PBXFileReference; lastKnownFileType = file.xib; name = en; path = en.lproj/ipjsuaViewController_iPhone.xib; sourceTree = "<group>"; };
 		3AF0582716F050780046B835 /* en */ = {isa = PBXFileReference; lastKnownFileType = file.xib; name = en; path = en.lproj/ipjsuaViewController_iPad.xib; sourceTree = "<group>"; };
-		3AFFF4D919BD59AB0067F226 /* libstdc++.dylib */ = {isa = PBXFileReference; lastKnownFileType = "compiled.mach-o.dylib"; name = "libstdc++.dylib"; path = "usr/lib/libstdc++.dylib"; sourceTree = SDKROOT; };
 		E5E991D41B67A45500017E67 /* libg7221codec.a */ = {isa = PBXFileReference; lastKnownFileType = archive.ar; path = libg7221codec.a; sourceTree = "<group>"; };
 		E5E991D51B67A45500017E67 /* libgsmcodec.a */ = {isa = PBXFileReference; lastKnownFileType = archive.ar; path = libgsmcodec.a; sourceTree = "<group>"; };
@@ -117,6 +119,6 @@
 			buildActionMask = 2147483647;
 			files = (
+				3A31F1B01DA4F54B007C23A3 /* libstdc++.tbd in Frameworks */,
 				E5E991EC1B67A45500017E67 /* libpjmedia-codec.a in Frameworks */,
-				3AFFF4DA19BD59AB0067F226 /* libstdc++.dylib in Frameworks */,
 				3AA31FF818F3FB4C00112C3D /* CFNetwork.framework in Frameworks */,
 				E5E991E61B67A45500017E67 /* libg7221codec.a in Frameworks */,
@@ -144,4 +146,5 @@
 				3AA31FFC18F3FB4C00112C3D /* CoreMedia.framework in Frameworks */,
 				E5E991F21B67A45500017E67 /* libpjsip.a in Frameworks */,
+				3A31F1B21DA4F568007C23A3 /* libwebrtc.a in Frameworks */,
 				E5E991F51B67A45500017E67 /* libresample.a in Frameworks */,
 				E5E991F61B67A45500017E67 /* libspeex.a in Frameworks */,
@@ -188,4 +191,5 @@
 			isa = PBXGroup;
 			children = (
+				3A31F1AF1DA4F54B007C23A3 /* libstdc++.tbd */,
 				3AA31FE918F3FB4C00112C3D /* AudioToolbox.framework */,
 				3AA31FEA18F3FB4C00112C3D /* AVFoundation.framework */,
@@ -238,6 +242,6 @@
 			isa = PBXGroup;
 			children = (
-				3AFFF4D919BD59AB0067F226 /* libstdc++.dylib */,
 				E5E991D41B67A45500017E67 /* libg7221codec.a */,
+				3A31F1B11DA4F568007C23A3 /* libwebrtc.a */,
 				E5E991D51B67A45500017E67 /* libgsmcodec.a */,
 				E5E991D61B67A45500017E67 /* libilbccodec.a */,