Index: pjproject/branches/projects/uwp/pjlib/build/pjlib.vcxproj
===================================================================
--- pjproject/branches/projects/uwp/pjlib/build/pjlib.vcxproj	(revision 5439)
+++ pjproject/branches/projects/uwp/pjlib/build/pjlib.vcxproj	(revision 5470)
@@ -605,5 +605,5 @@
       <ExcludedFromBuild Condition="'$(Configuration)|$(Platform)'=='Release|x64'">true</ExcludedFromBuild>
     </ClCompile>
-    <ClCompile Include="..\src\pj\ip_helper_generic.c">
+    <ClCompile Include="..\src\pj\ip_helper_winphone8.c">
       <ExcludedFromBuild Condition="'$(Configuration)|$(Platform)'=='Debug-Dynamic|Win32'">true</ExcludedFromBuild>
       <ExcludedFromBuild Condition="'$(Configuration)|$(Platform)'=='Debug-Dynamic|ARM'">true</ExcludedFromBuild>
@@ -628,5 +628,5 @@
       <ExcludedFromBuild Condition="'$(API_Family)'!='WinDesktop'">true</ExcludedFromBuild>
     </ClCompile>
-    <ClCompile Include="..\src\pj\ip_helper_winphone8.c">
+    <ClCompile Include="..\src\pj\ip_helper_generic.c">
       <ExcludedFromBuild Condition="'$(API_Family)'=='WinDesktop'">true</ExcludedFromBuild>
     </ClCompile>
Index: pjproject/branches/projects/uwp/pjlib/build/pjlib.vcxproj.filters
===================================================================
--- pjproject/branches/projects/uwp/pjlib/build/pjlib.vcxproj.filters	(revision 5439)
+++ pjproject/branches/projects/uwp/pjlib/build/pjlib.vcxproj.filters	(revision 5470)
@@ -186,7 +186,4 @@
       <Filter>Source Files\Other Targets</Filter>
     </ClCompile>
-    <ClCompile Include="..\src\pj\ip_helper_generic.c">
-      <Filter>Source Files\Other Targets</Filter>
-    </ClCompile>
     <ClCompile Include="..\src\pj\log_writer_printk.c">
       <Filter>Source Files\Other Targets</Filter>
@@ -226,4 +223,10 @@
     </ClCompile>
     <ClCompile Include="..\src\pj\ip_helper_winphone8.c">
+      <Filter>Source Files</Filter>
+    </ClCompile>
+    <ClCompile Include="..\src\pj\ip_helper_generic.c">
+      <Filter>Source Files</Filter>
+    </ClCompile>
+    <ClCompile Include="..\src\pj\ip_helper_generic.c">
       <Filter>Source Files</Filter>
     </ClCompile>
Index: pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_winuwp.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_winuwp.h	(revision 5439)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/compat/os_winuwp.h	(revision 5470)
@@ -115,5 +115,8 @@
 #define PJ_HAS_HIGH_RES_TIMER	    1
 #define PJ_HAS_MALLOC               1
-#define PJ_OS_HAS_CHECK_STACK	    1
+
+#ifndef PJ_OS_HAS_CHECK_STACK
+#   define PJ_OS_HAS_CHECK_STACK    0
+#endif
 
 #define PJ_ATOMIC_VALUE_TYPE	    long
Index: pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_uwp_comp.vcxproj
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_uwp_comp.vcxproj	(revision 5439)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_uwp_comp.vcxproj	(revision 5470)
@@ -92,4 +92,8 @@
     <Import Project="..\..\..\..\..\..\build\vs\pjproject-vs14-debug-static-defaults.props" />
   </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|x64'">
+    <Import Project="..\..\..\..\..\..\build\vs\pjproject-vs14-win64-common-defaults.props" />
+    <Import Project="..\..\..\..\..\..\build\vs\pjproject-vs14-debug-static-defaults.props" />
+  </ImportGroup>
   <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">
     <Import Project="..\..\..\..\..\..\build\vs\pjproject-vs14-arm-common-defaults.props" />
@@ -98,4 +102,8 @@
   <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">
     <Import Project="..\..\..\..\..\..\build\vs\pjproject-vs14-win32-common-defaults.props" />
+    <Import Project="..\..\..\..\..\..\build\vs\pjproject-vs14-release-dynamic-defaults.props" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|x64'">
+    <Import Project="..\..\..\..\..\..\build\vs\pjproject-vs14-win64-common-defaults.props" />
     <Import Project="..\..\..\..\..\..\build\vs\pjproject-vs14-release-dynamic-defaults.props" />
   </ImportGroup>
@@ -236,4 +244,5 @@
       <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
       <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <CompileAsWinRT>true</CompileAsWinRT>
       <DisableSpecificWarnings>28204</DisableSpecificWarnings>
Index: pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj	(revision 5439)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj	(revision 5470)
@@ -90,4 +90,8 @@
     <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-debug-static-defaults.props" />
   </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|x64'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-win64-common-defaults.props" />
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-debug-static-defaults.props" />
+  </ImportGroup>  
   <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">
     <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-arm-common-defaults.props" />
@@ -98,4 +102,8 @@
     <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-release-dynamic-defaults.props" />
   </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|x64'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-win64-common-defaults.props" />
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-release-dynamic-defaults.props" />
+  </ImportGroup>  
   <ImportGroup Label="ExtensionSettings">
   </ImportGroup>
@@ -217,4 +225,6 @@
       <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
       <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
+      <CompileAsWinRT>true</CompileAsWinRT>
       <AdditionalIncludeDirectories>..\..\..\..\..\..\..\pjsip\include;..\..\..\..\..\..\..\pjlib\include;..\..\..\..\..\..\..\pjlib-util\include;..\..\..\..\..\..\..\pjmedia\include;..\..\..\..\..\..\..\pjnath\include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
     </ClCompile>